//all "intelligent" stuff, the color behavior
//and flood fills

int g_fxtrigger=0;

//unused

int g_bayer[]={
  0x00,0xBF,0x30,0xEF,0x0C,0xCB,0x3B,0xFB,
  0x80,0x40,0xAF,0x70,0x8C,0x4C,0xBB,0x7C,
  0x20,0xDF,0x10,0xCF,0x2C,0xEB,0x1B,0xDB,
  0x9F,0x60,0x90,0x50,0xAB,0x6C,0x9B,0x5C,
  0x08,0xC7,0x38,0xF7,0x04,0xC4,0x34,0xF3,
  0x88,0x48,0xB7,0x78,0x82,0x44,0xB4,0x74,
  0x28,0xE8,0x18,0xD7,0x24,0xE4,0x14,0xD3,
  0xA7,0x68,0x98,0x57,0xA3,0x64,0x93,0x53};


int g_histogx,g_histogy;
int[]g_ahisto=new int[256];
int[]g_ahistoshow=new int[256];

void bpl_putxy(int x,int y,int c){
  int ad=(x+y*X)*g_planes;
  int cmp=1;
  for(int i=0;i<g_planes;i++){
    if((c&cmp)!=0){
      putbit(1024*8+ad+i,1);
    }else{
      putbit(1024*8+ad+i,0);
    }
    cmp=cmp*2;
  } 
}

int bpl_getxy(int x,int y,int mode){
  int ad=8192+(x+y*X)*g_planes;
  int cmp=1;
  int res=0;
  int rs=0;
  if(mode==0){
    for(int i=0;i<g_planes;i++){
      rs=getbit(ad+i);
      res=res+rs*cmp;
      cmp=cmp*2;
    }
    return res;  
  }
  if(mode==1){
    for(int i=0;i<g_planes;i++){
      rs=getbit_brush(ad+i);
      res=res+rs*cmp;
      cmp=cmp*2;
    }
    return res;  
  }

  if(mode==2){
    for(int i=0;i<g_planes;i++){
      rs=getbit_recallmap(ad+i);
      res=res+rs*cmp;
      cmp=cmp*2;
    }
    return res;  
  }  
  return 0;
}

void clear_autohistogram(){
  g_histogx=0;
  g_histogy=0;
  for(int i=0;i<256;i++){
    g_ahisto[i]=0;
    g_ahistoshow[i]=0;
  }
}

void force_autohistogram(){
  clear_autohistogram();
  for(int i=0;i<X*Y;i++){
    auto_histogrammer();
  }
  g_histogx=0;
  g_histogy=0;
}

void auto_histogrammer(){
  int idx=easygetcolor(g_histogx,g_histogy);
  if(idx<0)return;
  g_ahisto[idx]=1;
  g_histogx++;
  if(g_histogx>=X){
    g_histogx=0;
    g_histogy++;
    if(g_histogy>=Y){
      g_histogy=0;
      for(int i=0;i<256;i++){
        g_ahistoshow[i]=g_ahisto[i];
        g_ahisto[i]=0;
      }
    }
  }
}

boolean comparecolors(int c1,int c2){
  //if(c2==258)return false;
  if(c2>255)return false;
  if(c1>255)return false;
  if(c2<0)return false;
  if(c1<0)return false;
  if((g_r[c1]==g_r[c2])&&(g_g[c1]==g_g[c2])&&(g_b[c1]==g_b[c2]))return true;
  return false;
}

int find_rgb(color c){
  float dist=256*256*256;
  int target=-1;
  for(int i=0;i<g_maxcolors;i++){
    float ds=dist(g_r[i],g_g[i],g_b[i],red(c),green(c),blue(c));
    if(ds<dist){
      dist=ds;
      target=i;
    }      
  }
  return target;
}

void clever_background(int id){
  
  //for now only VIC, check usefulness for others
  if(int(g_map[13])!=VIC)return;
  
  int col=int(g_map[id]);
  int mem=g_farge;
    
  store_parameters();
  clear_parameters();
  
  for(int y=0;y<Y;y++){
    for(int x=0;x<X;x++){
      int c=easygetcolor(x,y);
      if(c==col){
        g_farge=col;
        makepoint(x,y);
        
      }
    }
  }
  g_farge=mem;
  restore_parameters();
  
}

void consistency()
{
  int xx,yy,ad,a,b,x0,y0,x2,y2;
  int pat,mat,fad,bad,maxxy,mulu,ymax;
  if(int(g_map[13])==ULAPLUS)return;
  if(g_multic==1||g_multic==2||g_multic==3||g_multic==4)return;
  
  maxxy=MY;
  mat=64;
  mulu=8;
  ymax=7;
  
  if(g_attrimode==0){mat=8;mulu=1;maxxy=Y;ymax=0;}
  for(yy=0;yy<MY;yy++){
    for(xx=0;xx<MX;xx++){
      a=getattra(xx*8,yy*mulu,0);
      b=getattra(xx*8,yy*mulu,1);
      if(a==b){
          for(y0=0;y0<=ymax;y0++){
             for(x0=0;x0<=7;x0++){
               ad=1024+(xx*8)+(yy*X*mulu)+x0+y0*X;
               g_map[ad]=byte(0);
           }
        }
      }
      pat=0;
       for(y0=0;y0<=ymax;y0++){
         for(x0=0;x0<=7;x0++){
           ad=1024+(xx*8)+(yy*X*mulu)+x0+y0*X;
           pat=pat+int(g_map[ad]);
         }
      }
      if(pat==mat||pat==0){
        for(y0=0;y0<=ymax;y0++){
          fad=65536+xx+(yy*mulu+y0)*MX;  
          bad=fad+(MX*MY*8);  
          if(pat==0)g_map[fad]=g_map[bad];
          if(pat==mat)g_map[bad]=g_map[fad];
        }      
      }
   }
  }
}


//clear_screen
//cls_screen
void global_clear(){
  int ad=0;
  int store=g_farge;
  clear_autohistogram();
  store_parameters();
  clear_parameters();
  g_farge=0;
  for(int i=1024;i<88000;i++){
    g_map[i]=0;
  }
  for(int pass=0;pass<1;pass++){
    for(int y=0;y<Y;y++){
      for(int x=0;x<X;x++){
        g_farge=1;
        makepoint(x,y);
      }
    }  
  }
  for(int pass=0;pass<2;pass++){
    for(int y=0;y<Y;y++){
      for(int x=0;x<X;x++){
        g_farge=g_backg;
        makepoint(x,y);
      }
    }  
  }
  g_farge=store;
  restore_parameters();
  // DO NOT do fillmap clear, otherwise there's nothing for the internal converter
  //fillmap_clear(); 
}

void clear_fxtrigger(int force)
{
  if(force==1){g_fxtrigger=1;return;}
  if(int(g_data[FX])==0)return;
  //if(int(g_map[12])==3)return;
  g_fxtrigger=1;
}

void fxmap_clear(){
  //using swap page as fx map
  for(int i=0;i<g_operations.length;i++){
    g_operations[i]=0;
  }
  g_fxtrigger=0;
}

void easy_fill(int ox,int oy,int f){
    int mb=g_button;
    store_parameters();
    g_data['X']=0;
    g_data['Y']=0;
    g_data['c']=0;
    g_data['t']=0;
    if(ox<0||oy<0||ox>=X||oy>=Y){
      //changeborder(mb);
    }
    
    if(ox>=0&&ox<X&&oy>=0&oy<Y){
      store_undo();// exceptional!
      if(g_multic!=0){
          if(g_multic==2||g_multic==3){
            floodfill_iq(ox,oy,mb);
          }else{
            floodfillmc(ox,oy,mb);
          }
        }
        else
        {
          floodfill_iq(ox,oy,mb);
        }
    }
    restore_parameters();
}

void fillmap_clear(){
  int ll=1024+(Y*X);
  //for(int i=0;i<g_fillmap.length;i++){
  for(int i=0;i<ll;i++){
    g_fillmap[i]=0;
  }
}

void fillmap_mark(int filter,int par){
  for(int y=0;y<Y;y++){
    for(int x=0;x<X;x++){
      if(easygetcolor(x,y)==filter)g_fillmap[x+y*X]=byte(par);
    }
  }
}

void fillmap_perform(int filter,int farge){
  store_parameters();
  clear_parameters();      
  g_farge=farge;
  for(int y=0;y<Y;y++){
    for(int x=0;x<X;x++){
      if(int(g_fillmap[x+y*X])==filter){
        makepoint(x,y);
      }
    }
  }  
  restore_parameters();
}


void color_clone(int from,int to){
  makecolor(to,g_r[from],g_g[from],g_b[from]);
}

void global_copy(int from,int to){   
  if(from==to)return;
  store_undo();
  makecolor(to,g_r[from],g_g[from],g_b[from]);
}

void global_exchange(int from,int to){
  if(from==to)return;
  touch();
  int store=g_farge;
  int pmode=int(g_data[FX]);
  g_data[FX]=0;

  int rswap=g_r[to];
  int gswap=g_g[to];
  int bswap=g_b[to];
  makecolor(to,g_r[from],g_g[from],g_b[from]);
  makecolor(from,rswap,gswap,bswap);
  fillmap_clear();
  fillmap_mark(from,1);
  fillmap_mark(to,2);
  fillmap_perform(1,to);
  fillmap_perform(2,from);
  g_farge=store;
  g_data[FX]=byte(pmode);
}

void global_recolor(int from,int to){
  int store=g_farge;
  store_undo();
  touch();
  g_farge=to;  
  int pmode=int(g_data[FX]);
  g_data[FX]=0;
  
  if(g_colorprofile[1]==1){
    if(int(g_map[1])==from){
     g_map[1]=byte(to);
    }    
  }
  
  if(g_colorprofile[2]==1){
    if(int(g_map[2])==from){
     g_map[2]=byte(to);
    }
  }
  
  for(int y=0;y<Y;y++){
    for(int x=0;x<X;x++){
      if(g_multic==2||g_multic==3||g_multic==4){
        if(easygetcolor(x,y)==from)makepoint(x,y);
      }else{
        if(comparecolors(easygetcolor(x,y),from)==true)makepoint(x,y);
      }
    }
  }
  g_farge=store;
  g_data[FX]=byte(pmode);
}

//internal set border
void set_border(int f){
  if(f<0)return;
  if(int(g_map[13])==ULAPLUS){
    if(f<8||f>23)return;
  }
  if(g_colorprofile[0]==0)return;
  g_map[0]=byte(zxcolor(f));
  sussborder();  
}

//manual set border
//AKA set_border make_border
void changeborder(int mou){
  int par=g_farge;
  if(mou==LEFT)par=g_farge;
  if(mou==RIGHT)par=g_backg;
  if(g_colorprofile[0]==0)return;    
  if((g_usablecolor[par]&1)==0){
    message("Cannot use|as border");
    return;
  }
  store_undo();
  message("Set border");  
  if(int(g_map[13])==ULAPLUS){
    if(par<8||par>15){
       message("Must be 8-15|in this mode");
       return;
    }
  }

  g_map[0]=byte(zxcolor(par));
  sussborder();
  g_boxreconstruct=2;
  refresh_all();
}

void palette_roll(int c1,int c2,int mode){

  int steps;
  if(c1>c2){
    steps=c1;
    c1=c2;
    c2=steps;
  } 
  int sr=g_r[c1];
  int sg=g_g[c1];
  int sb=g_b[c1]; 
  for(int i=c1;i<c2;i++){
    int src=i+1;
    if(src>c2)src=c1;
    if(mode==0){
      global_exchange(i,src);
    }
    if(mode==1){
      makecolor(i,g_r[src],g_g[src],g_b[src]);
    }
  }
  
  if(mode==1){
    makecolor(c2,sr,sg,sb);
  }
  
}

void palette_spread(int c1,int c2){

  store_undo();
  int i;
  float rfrom,gfrom,bfrom;
  float rto,gto,bto;
  float rstep,gstep,bstep;
  int steps;
  if(c1>c2){
    steps=c1;
    c1=c2;
    c2=steps;
  }
  i=c1;
  steps=c2-c1;
  rfrom=g_r[c1];
  gfrom=g_g[c1];
  bfrom=g_b[c1];
  rto=g_r[c2];
  gto=g_g[c2];
  bto=g_b[c2];  
  rstep=(rfrom-rto)/steps;
  gstep=(gfrom-gto)/steps;
  bstep=(bfrom-bto)/steps;
  float rr=rfrom;
  float gg=gfrom;
  float bb=bfrom;
  while(i<=c2){
    int rpos=round(rr/(g_divsr));
    int gpos=round(gg/(g_divsg));
    int bpos=round(bb/(g_divsb));
    int rep=int(g_stepr[rpos]);
    int gep=int(g_stepg[gpos]);
    int bep=int(g_stepb[bpos]);
    makecolor(i,int(rep),int(gep),int(bep));
    rr=rr-rstep;
    gg=gg-gstep;
    bb=bb-bstep;
    i++;
  }
}

void floodfillmc(int xx,int yy,int mou)
{
  int x,y,ax,ay,valid,okay;
  int npar=0;
  int par=0;

  fillmap_clear();
  
  if(g_pixelw==2){xx=xx/2;xx=xx*2;}
  if(mou==LEFT){par=g_farge;npar=getmultic(xx,yy,0);}
  if(mou==RIGHT){par=g_backg;npar=getmultic(xx,yy,0);}

  //println("par:"+par+" npar:"+npar);
  
  g_fillmap[1024+xx+yy*X]=byte(100);
  if(g_pixelw==2)g_fillmap[1024+xx+yy*X+1]=byte(0);
  valid=0;okay=0;
  
  while(okay==0){
    
    valid=0;

    for(x=0;x<X;x=x+g_pixelw){
      for(y=0;y<Y;y++){
        ax=int(g_fillmap[1024+x+y*X]);
        
        if(ax>=100&&ax<=199){
        valid=1;   
        if(y>0){
         if(getmultic(x,y-1,0)==npar&&g_fillmap[1024+x+(y-1)*X]==0){
             g_fillmap[1024+x+(y-1)*X]=byte(100);
             if(g_pixelw==2){g_fillmap[1024+x+(y-1)*X+1]=byte(0);}
             valid=1;
         } 
        }
        if(x>0){
           if(getmultic(x-g_pixelw,y,0)==npar&&g_fillmap[1024+(x-g_pixelw)+(y)*X]==0){
             g_fillmap[1024+(x-g_pixelw)+y*X]=byte(100);
             if(g_pixelw==2){g_fillmap[1024+(x-g_pixelw)+y*X+1]=byte(0);}
             valid=1;
           } 
        }      
        if(x<X-g_pixelw){
         if(getmultic(x+g_pixelw,y,0)==npar&&g_fillmap[1024+(x+g_pixelw)+(y)*X]==0){
             g_fillmap[1024+(x+g_pixelw)+y*X]=byte(100);
             if(g_pixelw==2){g_fillmap[1024+(x+g_pixelw)+y*X+1]=byte(0);}
             valid=1;
           } 
        }          
        if(y<Y-1){
         if(getmultic(x,y+1,0)==npar&&g_fillmap[1024+x+(y+1)*X]==0){
             g_fillmap[1024+x+(y+1)*X]=byte(100);
             if(g_pixelw==2){g_fillmap[1024+x+(y+1)*X+1]=byte(0);}
             valid=1;
           } 
        }      
        
         g_fillmap[1024+x+y*X]=byte(200);
         if(g_pixelw==2)g_fillmap[1024+x+y*X+1]=byte(0);
       }
      }
    }
    
    if(valid==0)okay=1;
  
  }  
  
  for(x=0;x<X;x=x+g_pixelw){
    for(y=0;y<Y;y++){
      if(int(g_fillmap[1024+x+y*X])>=200){
        g_farge=par;
        pre_examine_mc(x,y,par,0);
        makepoint(x,y);
        g_farge=g_ofarge;
      }
   }
  }  
  fillmap_clear();
}

void flip(){
  int o=g_farge;
  int DX=MX;
  int DY=MY;
  if(g_machine==VIC||g_machine==VICM){DX=MX/2;DY=MY/2;}
  store_undo();
  store_parameters();
  clear_parameters();
  for(int y=0;y<DY;y++){    
    for(int x=0;x<DX;x++){     
      for(int yy=0;yy<CY;yy++){
        for(int xx=0;xx<CX;xx++){
          int c=easygetcolor(x*CX+xx,y*CY+yy);
          g_fillmap[(DX-(x+1))*(CX*CY)+xx+yy*CY]=byte(c);
        }
      }
    }    
    for(int x=0;x<DX;x++){
      for(int yy=0;yy<CY;yy++){
        for(int xx=0;xx<CX;xx++){
          g_farge=0;
          makepoint(x*CX+xx,y*CY+yy);
          clearpoint(x*CX+xx,y*CY+yy);
        }
      }
      for(int pass=0;pass<2;pass++){
        for(int yy=0;yy<CY;yy++){
          for(int xx=0;xx<CX;xx++){
            g_farge=int(g_fillmap[x*(CX*CY)+((CX-1)-xx)+yy*CY]);
            makepoint(x*CX+xx,y*CY+yy);
          }
        }
      }
    }      
    }   
    
  restore_parameters();
  refresh_all();
  g_farge=o;
}

int findclosest(float r,float g,float b){
  int target=-1;
  float dista=65536;
  for(int i=0;i<g_maxcolors;i++){
    float dtest=dist(r,g,b,g_r[i],g_g[i],g_b[i]);
    if(dtest<dista){
      dista=dtest;
      target=i;
    }
  }
  return target;
}

void floodfill_iq(int xx,int yy,int mou)
{
  int fillp,valid,okay;
  int minx=xx;
  int miny=yy;
  int maxx=xx;
  int maxy=yy;
  
  if(int(g_map[13])==ULAPLUS){
    floodfill_ula(xx,yy,mou);
    return;
  }
  int par=g_farge;
  if(mou==RIGHT)par=g_backg;
  if(easygetcolor(xx,yy)==par)return;
  int npar = easygetcolor(xx,yy);
  
  int store=int(g_data[FX]);//fxmode
  g_data[FX]=0;
  fillmap_clear();
  
  g_fillmap[1024+xx+yy*X]=byte(100);
  valid=0;
  okay=0;
  
  while(okay==0){
    valid=0;

    for(int x=minx;x<=maxx;x++){
      for(int y=miny;y<=maxy;y++){
        fillp=int(g_fillmap[1024+x+y*X]);
        if(fillp==100){
          valid=1;   
          if(y>0){
             if(easygetcolor(x,y-1)==npar && g_fillmap[1024+x+(y-1)*X]==0){
               g_fillmap[1024+x+(y-1)*X]=byte(100);valid=1;
               if(y-1<miny)miny=y-1;
             } 
          }
          if(x>0){
             if(easygetcolor(x-1,y)==npar && g_fillmap[1024+(x-1)+y*X]==0){
               g_fillmap[1024+(x-1)+y*X]=byte(100);valid=1;
               if(x-1<minx)minx=x-1;
             } 
          }      
          if(x<X-1){
             if(easygetcolor(x+1,y)==npar && g_fillmap[1024+(x+1)+y*X]==0){
               g_fillmap[1024+(x+1)+y*X]=byte(100);valid=1;
               if(x+1>maxx)maxx=x+1;
             } 
          }          
          if(y<Y-1){
             if(easygetcolor(x,y+1)==npar && g_fillmap[1024+x+(y+1)*X]==0){
               g_fillmap[1024+x+(y+1)*X]=byte(100);valid=1;
               if(y+1>maxy)maxy=y+1;
             } 
          }      
          g_fillmap[1024+x+y*X]=byte(200);
        }
      }
    }
    if(valid==0)okay=1;
  }
  
  for(int x=0;x<X;x++){
    for(int y=0;y<Y;y++){
      if(int(g_fillmap[1024+x+y*X])==200){
         g_farge=par;
         makepoint(x,y);
      } 
    }
  }
  g_farge=g_ofarge; 
  g_data[FX]=byte(store);
}

//adaptive color helper for low-attribute modes
//reasons the background color for each char as you draw
//=changed

void fixbrightness(int x,int y,int br){
  
  int miny=getblockminy(y);
  int maxy=getblockmaxy(y);
  int yblock=y/CY;
  
  for(int i=miny;i<=maxy;i++){
    int bad=65536+(x/8)+(yblock*CY+i)*MX;
    int cad=bad+MX*(MY*8);
    int c1=int(g_map[bad]);
    int c2=int(g_map[cad]);
    if(c1>=8)c1=c1-8;
    if(c2>=8)c2=c2-8;
    if(br==1){
      c1=c1+8;
      c2=c2+8;
    }
    if(c1==8)c1=0;
    if(c2==8)c2=0;
    g_map[bad]=byte(c1);
    g_map[cad]=byte(c2);
  }
  updatepoint(x,y);  
}

void fixattr(int x,int y,int foreg,int backg)
{
  int bad,cad,miny,maxy;
  
  if(g_britemode==1){
    if(foreg==8||backg==8||foreg==0||backg==0)return;
  }
  
  miny=getblockminy(y);
  maxy=getblockmaxy(y);
  
  for(int i=miny;i<=maxy;i++){
    bad=65536+(x/8)+(y+i)*MX;
    cad=bad+MX*(MY*8);
    if(foreg>=0){
      g_map[bad]=byte(foreg);
      if(foreg>=8&&g_map[cad]<8)g_map[cad]=byte(g_map[cad]+8);
      if(foreg<8&&g_map[cad]>=8)g_map[cad]=byte(g_map[cad]-8);    
    }
    if(backg>=0){
      g_map[cad]=byte(backg);
      if(backg>=8&&g_map[bad]<8)g_map[bad]=byte(g_map[bad]+8);
      if(backg<8&&g_map[bad]>=8)g_map[bad]=byte(g_map[bad]-8);        
    }
  }
  updatepoint(x,y);
}

//multicolor color behavior
//different behavior depending on whether color area already has max colors,
//or if forcecolor is pressed.
//bit different for C64 and PLUS4M

void skaveri(int x,int y,int foreg,int backg)
{
  int mx=x/8;
  int my=y/8;
  if(g_control==false)return;
  //if(g_multic==3)return;
  //if(g_multic==4)return;
  if(g_remdo[mx+my*MX]==1)return;
  store_parameters();
  clear_parameters();
  g_remdo[mx+my*MX]=1;
  g_ccontroller=0;
  int cc=easygetcolor(x,y);
  mx=mx*8;
  my=my*8;
  int far=0;
  if(g_button==LEFT)far=g_farge;
  if(g_button==RIGHT)far=g_backg;
  for(int xx=0;xx<=7;xx++){
    for(int yy=0;yy<=7;yy++){
      if(easygetcolor(mx+xx,my+yy)==cc){
        makepoint(mx+xx,my+yy);
      }
    }
  }
  updatepoint(x,y);
  restore_parameters();
  
}

// pre-examine tiles for multicolor modes




void pre_examine_mc(int x,int y,int foreg,int backg)
{
  int mx=x/CX;
  int my=y/CY;
  int ad,cad,dad,b0,b1;
  int f0,f1,f2,f3,free1,free2,free3;
  int f;
  int order=0;
  int numb=0;
  int targetbit0=0;
  int targetbit1=0;
  int suffocatelimit=7;//bitpattern related
  
  //e.g. 01=1  C64 1-7 = 7 = suffocated
  //     10=2
  //     11=4
  
  //     01=1 PLUS4 1-3 = 3 = suffocated
  //     10=2 
  
  //     01=1 VICM  1   = 1 = suffocated
  
  int DX=MX;
  if(g_machine==VIC)DX=MX/2;
  
  if(g_multic==2||g_multic==3||g_multic==4)return;
  
  f=getmultic(x,y,0);
  
  if(g_data['d']==1&&f!=g_backg)return;
  
  //println("mx,my:"+mx+"."+my);
  cad=65536+mx+(my*DX);
  
  f0=int(g_map[1]); 
  f1=int(g_map[cad]);free1=1;        
  f2=int(g_map[cad+1000]);free2=1;
  f3=int(g_map[cad+2000]);free3=1;
  
  if(g_machine==PLUS4M){
    free3=0;
    suffocatelimit=3;
    f3=int(g_map[2]);
  }  
  
  if(g_machine==VICM){
    free3=0;
    suffocatelimit=1;
    f2=int(g_map[0]);//border=Global
    
    f3=int(g_map[2]);
  }
  
  if(g_machine==VIC){
    free2=0;
    free3=0;
    f2=int(g_map[1]);
    f3=int(g_map[1]);
    suffocatelimit=1;
  } 
  
  if(foreg==g_map[1]&&g_control==false){
   // println("escape");
    return;
  }
 // find the level of "suffocation"
 // which bitpatterns (00,01,10,11) are present?
 
 // f=color under
 
  if(foreg!=f1&&foreg!=f2&&foreg!=f3||g_control==true){
   for(int yy=0;yy<CY;yy++){
      for(int xx=0;xx<CXM;xx++){
        ad=1024+(mx*CX+xx*2)+(my*CY+yy)*X;
        if(g_map[ad]==0&&g_map[ad+1]==0){//00 = 00
          if(f0==f)order=4;
        }        
        if(g_map[ad]==1&&g_map[ad+1]==0){//01 = 10
          numb=numb|1;
          free1=0;
          if(f1==f)order=1;
        }
        if(g_map[ad]==0&&g_map[ad+1]==1){//02 = 01
          numb=numb|2;
          free2=0;
          if(f2==f)order=2;
        }
        if(g_map[ad]==1&&g_map[ad+1]==1){//03 = 11
          if(g_machine==C64M){
            numb=numb|4;
            free3=0;
          }
          if(f3==f){
            order=3;
            targetbit0=1;
            targetbit1=1;
          }
        }      
      }
    }
   
   if(g_machine==VICM)numb=numb&1;
   //numb1==1 , the most common colormap is full
   
   boolean zoink=false;
   if(order==4)zoink=true;
   if(order==3&&g_machine==PLUS4M)zoink=true;
   if(order==3&&g_machine==VICM)zoink=true;
   
   // only if control key is pressed
   
   if((zoink||numb!=suffocatelimit)&&g_control==true){
     if(zoink){ 
     //  println("foreg:"+foreg+" f0:"+f0+" f1:"+f1+" f2:"+f2+" f3:"+f3+" free1:"+free1+" free2:"+free2+" free3:"+free3);
       b0=-1;b1=-1;
       if(foreg==f1&&free1==0){b0=1;b1=0;}
       if(foreg==f2&&free2==0){b0=0;b1=1;}
       if(foreg==f3&&g_machine==C64M&&free3==0){b0=1;b1=1;}
       if(foreg==f3&&g_machine==PLUS4M){b0=1;b1=1;}
       if(foreg==f3&&g_machine==VICM){b0=1;b1=1;}
       
       if(free1==1){
         free2=0;free3=0;b0=1;b1=0;g_map[cad]=byte(foreg);
       }
       if(free2==1){
         free3=0;b0=0;b1=1;g_map[cad+1000]=byte(foreg);
       }
       if(free3==1){
         b0=1;b1=1;g_map[cad+2000]=byte(foreg);
       }
       
       for(int yy=0;yy<CY;yy++){
          for(int xx=0;xx<CXM;xx++){
            ad=1024+(mx*CX+xx*2)+(my*CY+yy)*X;
            if(g_map[ad]==targetbit0&&g_map[ad+1]==targetbit1){
              if(b0>=0){
                g_map[ad]=byte(b0);
                g_map[ad+1]=byte(b1);
              }
            }
          }
       }
     }
   }
   
   // normal , no control pressed
   // if all color positions are filled, we'll just change the existing one
   
  // println(numb+"/"+suffocatelimit);
   
    if(numb==suffocatelimit||g_control==true){
   //   println("happening");
      if(order==1){g_map[cad]=byte(foreg);}//10==1
      if(order==2){g_map[cad+1000]=byte(foreg);}//01==2
      if(order==3&&g_machine==C64M){g_map[cad+2000]=byte(foreg);}//11==3  
    }
    
    //color redundancy check
    
           
            
      for(int yy=0;yy<CY;yy++){
          for(int xx=0;xx<CXM;xx++){
            ad=1024+(mx*CX+xx*2)+(my*CY+yy)*X;
            
            if(g_machine==C64M){
              if(g_map[cad]==g_map[cad+2000]){
                if(g_map[ad]==1&&g_map[ad+1]==1){
                  g_map[ad]=1;g_map[ad+1]=0;
                }
              }
              if(g_map[cad+1000]==g_map[cad+2000]){
                if(g_map[ad]==1&&g_map[ad+1]==1){
                  g_map[ad]=0;g_map[ad+1]=1;
                }
              }                 
            //extras
              if(g_map[cad]==g_map[cad+1000]){
                if(g_map[ad]==0&&g_map[ad+1]==1){
                  g_map[ad]=1;g_map[ad+1]=0;
                }
              }
              if(g_map[1]==g_map[cad]){
                  if(g_map[ad]==1&&g_map[ad+1]==0){
                  g_map[ad]=0;g_map[ad+1]=0;
                  }
              }
              if(g_map[1]==g_map[cad+1000]){
                  if(g_map[ad]==0&&g_map[ad+1]==1){
                    g_map[ad]=0;g_map[ad+1]=0;
                  }
              }        
            } 
            
            if(g_machine==PLUS4M){
             //extras
             
                if(g_map[cad]==g_map[cad+1000]){
                  if(g_map[ad]==0&&g_map[ad+1]==1){
                    g_map[ad]=1;g_map[ad+1]=0;
                  }
                }
                
              if(g_map[1]==g_map[cad]){
                  if(g_map[ad]==1&&g_map[ad+1]==0){
                  g_map[ad]=0;g_map[ad+1]=0;
                  }
              }
              if(g_map[1]==g_map[cad+1000]){
                  if(g_map[ad]==0&&g_map[ad+1]==1){
                    g_map[ad]=0;g_map[ad+1]=0;
                  }
              }  
              
              
              //plus4
              
              if(g_map[2]==g_map[cad]){
                  if(g_map[ad]==1&&g_map[ad+1]==0){
                  g_map[ad]=1;g_map[ad+1]=1;
                  }
              }
              if(g_map[2]==g_map[cad+1000]){
                  if(g_map[ad]==0&&g_map[ad+1]==1){
                    g_map[ad]=1;g_map[ad+1]=1;
                  }
              }
              if(g_map[1]==g_map[2]){
                if(g_map[ad]==1&&g_map[ad+1]==1){
                  g_map[ad]=0;g_map[ad+1]=0;
                }
              }              
            }

/*
             if(g_machine==VICM){
              if(g_map[2]==g_map[cad]){//backnd2
                  if(g_map[ad]==1&&g_map[ad+1]==0){
                    g_map[ad]=1;g_map[ad+1]=1;
                  }
              }
              if(g_map[1]==g_map[cad]){//backgnd
                if(g_map[ad]==1&&g_map[ad+1]==1){
                  g_map[ad]=0;g_map[ad+1]=0;
                }
              }
              if(g_map[0]==g_map[cad]){//borderbackng
                if(g_map[ad]==1&&g_map[ad+1]==1){
                  g_map[ad]=0;g_map[ad+1]=0;
                }
              }                  
            }
            
            */
            if(g_machine==C64M){
              if(g_map[1]==g_map[cad+2000]){
                  if(g_map[ad]==1&&g_map[ad+1]==1){
                    g_map[ad]=0;g_map[ad+1]=0;
                  }
              }               
            }
          }
      }
    }
    updatepoint(x,y);
}

int getbrightness(int c){
  if(c>=9)return 1;
  return 0;
}



// experiment with unique char detector
// c64mc mostly

int g_charid[]=new int[80*50];
int g_charcol[]=new int[80*50];
int g_charmarker[]=new int[80*50];

int g_unicount=0;
int g_uniques=0;
int g_global_colors=0;

int g_chardat[]=new int[81921];
int g_charping=0;
int g_charpass=0;
int g_charcc=0;

int g_globals=0;
int g_global[]=new int[256];

int g_candis=0;
int g_candi[]=new int[256];

int g_pairs=0;
int g_pair[]=new int[256];


void reset_uq_engine(){
  g_charping=0;
  g_charpass=0;
  g_charcc=0;
}

void force_unique_chars(){
  g_charping=0;  
  g_charpass=0;
  for(int i=0;i<=MX*MY-1;i++){
    unique_chars();
    unique_chars();
  }
}

void add_pair(int p1,int p2){
  int hilo=p1*256+p2;
  int lohi=p1+p2*256;
  for(int i=0;i<g_pairs;i++){
    if(g_pair[i]==hilo)return;
    if(g_pair[i]==lohi)return;
  }
  g_pair[g_pairs]=hilo;
  g_pairs++;
}

void add_global(int c){
  if(int(g_map[1])==c)return;
  for(int i=0;i<g_globals;i++){
    if(g_global[i]==c)return;
  }
  g_global[g_globals]=c;
  g_globals++; 
}

void add_candidate(int c){
  for(int i=0;i<g_candis;i++){
    if(g_candi[i]==c)return;
  }
  g_candi[g_candis]=c;
  g_candis++;  
}

// background=uncontested global
// 8-15 colors=uncontested global
// 0-7 identify possible pairs and "vote" for the 1-2 global colors (it's possible to have background + 2 x 0-7color globals)


void unique_chars(){
  if(MX*MY*64>81920){
    g_uniques=-1;
    return;
  }
  
  int perchar=0;
  
    if(g_charping==0){ // start pass 0, solutions cleared
      if(g_charpass==0){
        g_unicount=0;
        g_charcc=0;
        for(int i=0;i<g_chardat.length;i++){
          g_chardat[i]=-1;   
        }
        for(int i=0;i<g_charmarker.length;i++){
          g_charmarker[i]=0;
        }
        g_candi[0]=-1;g_candi[1]=-1;g_candi[2]=-1;g_candi[3]=-1;
        g_candi[4]=-1;g_candi[5]=-1;g_candi[6]=-1;g_candi[7]=-1;
        g_candis=0;
        g_globals=0;
        g_pairs=0;
      }
      
      if(g_charpass==1){ // start pass 1, solutions from pass 0 are now available
      //  print("candidates:");
       // for(int i=0;i<g_candis;i++)
        //print((g_candi[i])+",");
     //   println("");
     //   print("pairs:");
        int vote[]=new int[16];
        for(int i=0;i<vote.length;i++)vote[i]=0;
        for(int i=0;i<g_pairs;i++){
          int p1=(g_pair[i]&0xff00)/256;
          int p2=(g_pair[i]&0x00ff);
          vote[p1]++;
          vote[p2]++;
        //  print(p1+"/"+p2+" , ");
        }
      //  println();
        if(g_pairs==1){
          if(g_globals==2){
            if((g_global[0]>7)&&(g_global[1]>7)){
           //   g_pairs=0;
            }
          }
        }
        if(g_pairs==1){ // if one pair, doesn't matter which
          
          add_global(g_pair[0]&0x00ff);
        }
        int target=-1;
        int best=-1;
        int secondbest=-1;
        for(int i=0;i<16;i++){
          if(vote[i]>target&&vote[i]>1){
            best=i;
            target=vote[i];
          }    
        }
        target=-1;
        for(int i=0;i<16;i++){
          if(i!=best&&vote[i]>target&&vote[i]>1){
            secondbest=i;
            target=vote[i];
          }    
        }      
    //    println("best:"+best+" second best:"+secondbest);
        if(best>=0)add_global(best);
        if(secondbest>=0)add_global(secondbest);
    //    println();      
      //  print("globals:");
     //   for(int i=0;i<g_globals;i++){
       //   print(g_global[i]+" , ");
      //  }
     //  println();
    }
  }
  
  int okay=0;
  int ypos=g_charping/MX;
  int xpos=g_charping-(ypos*MX);
  
  for(int y=ypos;y<ypos+1;y++){
    for(int x=xpos;x<xpos+1;x++){
      int more=0;
      
      if(g_charpass==0){ // pass 0 = find uncontested globals and candidates
        g_candis=0;
          g_candi[0]=-1;g_candi[1]=-1;g_candi[2]=-1;g_candi[3]=-1;
          g_candi[4]=-1;g_candi[5]=-1;g_candi[6]=-1;g_candi[7]=-1;
          for(int xx=0;xx<8;xx++){
            for(int yy=0;yy<8;yy++){
              int col=easygetcolor(x*8+xx,y*8+yy);
              if(col>=8)add_global(col);
              if((col<8)&&(col!=int(g_map[1]))){
                add_candidate(col);
              }
            }
           }
             if(g_candis==2){ // pairs made of 0-7 colors
               add_pair(g_candi[0],g_candi[1]);    
             }          
             if(g_candis>2){ // pairs made of 0-7 colors
               add_pair(g_candi[0],g_candi[1]);
               add_pair(g_candi[0],g_candi[2]);
               add_pair(g_candi[1],g_candi[2]);
             }
       }
      
      if(g_charpass==1){ // pass 1 = find chars
        perchar=-1;
        for(int xx=0;xx<8;xx++){
          for(int yy=0;yy<8;yy++){
            int col=easygetcolor(x*8+xx,y*8+yy);
            g_chardat[g_charcc*64+xx+yy*8]=col;
            if(col<8&&perchar==-1){
              perchar=col;
            }
          }
        }
                                          
        int fail=0;
        for(int d=0;d<g_charcc;d++){
          okay=0;
            for(int xx2=0;xx2<8;xx2++){
              for(int yy2=0;yy2<8;yy2++){
                int comp1=g_chardat[d*64+xx2+yy2*8];
                int comp2=g_chardat[g_charcc*64+xx2+yy2*8];
                
                if(g_machine==C64M){
                  if(comp1==g_map[1])comp1=16;
                  if(comp2==g_map[1])comp2=16;    
                  for(int i=0;i<g_globals;i++){
                    if(comp1==g_global[i])comp1=256+i;
                    if(comp2==g_global[i])comp2=256+i;
                  }
                  if(comp1<8)comp1=1;
                  if(comp2<8)comp2=1;
                }
                
                if(comp1==comp2){
                  okay++;
                }
              }
            }  
            if(okay==64){
              fail=1;   
              g_charid[x+y*MX]=d; 
              g_charcol[x+y*MX]=perchar;
              break;
            }                    
          }
          if(fail==0){          
              g_charid[x+y*MX]=g_charcc;  
              g_charcol[x+y*MX]=perchar;
              if(g_globals>2){                
                g_redo[x+y*MX]=0;
              }
              g_charcc++;
              g_unicount++;  
          }
                   
      }
    }
  }
  
  g_charping++;
  
  if(g_charping==(MX*MY)){
    //println("g_charpass:"+g_charpass);
    //println("g_unicount:"+g_unicount);
     if(g_charpass==1){
      g_uniques=g_unicount;
      g_global_colors=g_globals;
      g_map[22]=byte(255);
      g_map[23]=byte(255);
      if(g_global[0]>=0){g_map[22]=byte(g_global[0]);}
      if(g_global[1]>=0){g_map[23]=byte(g_global[1]);}
     }
    g_charping=0;    
    g_charpass++;
    if(g_charpass>1)g_charpass=0;
  }  
}

void char_crunch(){
  int store=g_farge;
  store_undo();
  force_unique_chars();
 // println("uniques:"+g_uniques);
  int ad=0;
  int x=0;
  int y=0;
  
  for(int i=0;i<g_uniques;i++){
      for(int yy=0;yy<8;yy++){
        for(int xx=0;xx<8;xx++){        
         g_farge=int(g_chardat[ad*64+xx+yy*8]);
         if(g_farge>=0){
           makepoint(x*8+xx,y*8+yy);
         }
        }
      }
      ad++;
      x++;
      if(x>=MX){x=0;y++;}
  }
  g_farge=store;

}
